<?php

namespace HelpieFaq\Features\Faq;

if (!defined('ABSPATH')) {
    exit;
} // Exit if accessed directly

if (!class_exists('HelpieFaq\Features\Faq\Settings_Handlers')) {

    class Settings_Handlers
    {

        public function get_interpreted_settings_args(array $setting_args)
        {
            // get dark theme styles
            $args = $this->get_dark_theme_styles_args($setting_args);
            $is_premium = hf_fs()->is__premium_only() ? true : false;
            if ($is_premium == false) {
                return $args;
            }
            $args = $this->get_custom_background_args($args, $setting_args);
            return $args;
        }

        public function get_custom_background_args(array $args, array $setting_args)
        {

            $is_accordion_backgrounds_changed = $this->is_accordion_backgrounds_changed($setting_args);
            if (!$is_accordion_backgrounds_changed) {
                return $args;
            }
            return $setting_args;
        }

        public function get_dark_theme_styles_args(array $setting_args)
        {
            if (isset($setting_args['theme']) && $setting_args['theme'] != 'dark') {
                return $setting_args;
            }
            $dark_theme_background_styles = $this->get_default_dark_theme_background_styles();
            return array_merge($setting_args, $dark_theme_background_styles);
        }

        public function get_default_dark_theme_background_styles()
        {
            return [
                'accordion_background' => [
                    'header' => '#171717',
                    'body' => '#272727',
                ],
            ];
        }

        public function is_accordion_backgrounds_changed(array $setting_args)
        {
            $getter = new \HelpieFaq\Includes\Settings\Getters\Getter();
            $default_accordion_backgrounds = $getter->get_premium_styles_fields()['accordion_background'];
            $user_defined_accordion_backgrounds = $setting_args['accordion_background'];
            $matched = array_diff($default_accordion_backgrounds, $user_defined_accordion_backgrounds);
            return empty($matched) ? false : true;
        }
    }
}